- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# cs_project – Manages projects on Apache CloudStack based clouds

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Create, update, suspend, activate and remove projects.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- cs >= 0.6.10

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
account string |  | Account the project is related to.
api_http_method string | Choices: get post | HTTP method used to query the API endpoint. If not given, the `CLOUDSTACK_METHOD` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes. Fallback value is `get` if not specified.
api_key string |  | API key of the CloudStack API. If not given, the `CLOUDSTACK_KEY` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_region string | Default: "cloudstack" | Name of the ini section in the `cloustack.ini` file. If not given, the `CLOUDSTACK_REGION` env variable is considered.
api_secret string |  | Secret key of the CloudStack API. If not set, the `CLOUDSTACK_SECRET` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_timeout integer |  | HTTP timeout in seconds. If not given, the `CLOUDSTACK_TIMEOUT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes. Fallback value is 10 seconds if not specified.
api_url string |  | URL of the CloudStack API e.g. https://cloud.example.com/client/api. If not given, the `CLOUDSTACK_ENDPOINT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
display_text string |  | Display text of the project. If not specified, name will be used as display_text.
domain string |  | Domain the project is related to.
name string / required |  | Name of the project.
poll_async boolean | Choices: no yes ← | Poll async jobs until job has finished.
state string | Choices: present ← absent active suspended | State of the project.
tags list |  | List of tags. Tags are a list of dictionaries having keys key and value. If you want to delete all tags, set a empty list e.g. tags: []. aliases: tag

## Notes

Note

- Ansible uses the `cs` library’s configuration method if credentials are not provided by the arguments `api_url`, `api_key`, `api_secret`. Configuration is read from several locations, in the following order. The `CLOUDSTACK_ENDPOINT`, `CLOUDSTACK_KEY`, `CLOUDSTACK_SECRET` and `CLOUDSTACK_METHOD`. `CLOUDSTACK_TIMEOUT` environment variables. A `CLOUDSTACK_CONFIG` environment variable pointing to an `.ini` file. A `cloudstack.ini` file in the current working directory. A `.cloudstack.ini` file in the users home directory. Optionally multiple credentials and endpoints can be specified using ini sections in `cloudstack.ini`. Use the argument `api_region` to select the section name, default section is `cloudstack`. See https://github.com/exoscale/cs for more information.
- A detailed guide about cloudstack modules can be found in the CloudStack Cloud Guide.
- This module supports check mode.

## Examples

    - name: Create a project
      cs_project:
        name: web
        tags:
          - { key: admin, value: john }
          - { key: foo,   value: bar }
      delegate_to: localhost

    - name: Rename a project
      cs_project:
        name: web
        display_text: my web project
      delegate_to: localhost

    - name: Suspend an existing project
      cs_project:
        name: web
        state: suspended
      delegate_to: localhost

    - name: Activate an existing project
      cs_project:
        name: web
        state: active
      delegate_to: localhost

    - name: Remove a project
      cs_project:
        name: web
        state: absent
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
account string | success | Account the project is related to. Sample: example account
display_text string | success | Display text of the project. Sample: web project
domain string | success | Domain the project is related to. Sample: example domain
id string | success | UUID of the project. Sample: 04589590-ac63-4ffc-93f5-b698b8ac38b6
name string | success | Name of the project. Sample: web project
state string | success | State of the project. Sample: Active
tags list | success | List of resource tags associated with the project. Sample: [ { "key": "foo", "value": "bar" } ]

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]
- This module is maintained by the Ansible Community. [community]

### Authors

- René Moser (@resmo)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.